@page quick_start_guide Quick Start Guide
@htmlonly
<div class="autonumbering">
@endhtmlonly



@tableofcontents



@section quick_start_license_agreement License Agreement
© Copyright {{ year }} {{ name_of_copyright_owner }}

{{ license }}



@section quick_start_guide_id Document Information
ID | Name | Version
-- | ---- | -------
001 | Quick Start Guide | v.1.0


@subsection quick_start_guide_description Description
This document is a short guide to running the {{ full_name }} UVM Agent in its own Self-Test Bench.

![uvma_{{ name }}_agent_c Block Diagram](agent_block_diagram.svg)



@section quick_start_guide_revision_history Revision History
Revision  | Date | Description
--------- | ---- | -----------
1.0 | {{ year }}/01/01 | Initial Version



@section quick_start_guide_definitions Definitions
Symbol | Definition
------ | ----------
 {{ mode_1.upper() }} | TODO Describe {{ mode_1.upper() }}
 {{ mode_2.upper() }} | TODO Describe {{ mode_2.upper() }}



@section quick_start_guide_prerequisites Pre-Requisites
The Moore.io Client CLI, used throughout this tutorial is available via "pipx":
@code{.sh}pipx install mio-client@endcode



@section quick_start_guide_introduction Introduction
The {{ full_name }} UVM Agent has a Self-Test UVM Environment & Test Bench pair used to verify the former thoroughly
against itself.  One agent is instantiated as {{ mode_1 }} and the other as {{ mode_2 }}.  Both driver/monitor and 
monitor/monitor scoreboarding is done in both directions.

This guide will walk you through running a test generating random traffic in both directions.



@section quick_start_guide_installation Installation
1. Install the {{ full_name }} UVM Agent: @code{.sh}mio install uvma_{{ name }}@endcode
2. Install the {{ full_name }} UVM Agent Self-Test UVM Environment: @code{.sh}mio install uvme_{{ name }}_st@endcode
3. Install the {{ full_name }} UVM Agent Self-Test UVM Test Bench: @code{.sh}mio install uvmt_{{ name }}_st@endcode


@section quick_start_guide_compile_elaborate Compile and Elaborate
1. Compile the {{ full_name }} UVM Agent Self-Test UVM Test Bench: @code{.sh}mio sim uvmt_{{ name }}_st -C@endcode
2. Elaborate the {{ full_name }} UVM Agent Self-Test UVM Test Bench with wave capture enabled: @code{.sh}mio sim uvmt_{{ name }}_st -E -w@endcode


@section quick_start_guide_simulate Simulate
Launch {{ full_name }} UVM Agent Self-Test UVM Test "rand_stim" with seed "1" and "10" transactions in both directions:
@code{.sh}mio sim uvmt_{{ name }}_st -S -t rand_stim -s 1 -w -- +NUM_SEQ_ITEMS=10@endcode



@section quick_start_guide_results Results
The Moore.io CLI will printout the commands to view both the simulation logs (don't forget to check out the "trn_log"
directory for transaction logs) and waveforms.



@section quick_start_guide_conclusion Conclusion
That's all for this short guide.  For more information, including integration, have a look at the @subpage user_guide "User Guide".



@htmlonly
</div>
@endhtmlonly
