// Copyright {{ year }} {{ name_of_copyright_owner }}
// {{ license }}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


`ifndef __UVMA_{{ name.upper() }}_CNTXT_SV__
`define __UVMA_{{ name.upper() }}_CNTXT_SV__


/**
 * Object encapsulating all state variables for all {{ full_name }} agent (uvma_{{ name }}_agent_c) components.
 * @ingroup uvma_{{ name }}_obj
 */
class uvma_{{ name }}_cntxt_c extends uvml_cntxt_c;

   virtual uvma_{{ name }}_if  vif; ///< Handle to agent interface

   /// @name Objects
   /// @{
   uvm_event  sample_cfg_e  ; ///< Triggers sampling of the agent configuration by the functional coverage model.
   uvm_event  sample_cntxt_e; ///< Triggers sampling of the agent context by the functional coverage model.
   /// @}

   /// @name State Variables
   /// @{
   uvml_reset_state_enum  reset_state; ///< Reset state as observed by monitor (uvma_{{ name }}_mon_c).
   {% if mm %}uvml_ral_mem_model_c  memory; ///< Handle to memory model for active {{ mode_2.upper() }} instances.
   uvma_{{ name }}_{{ mode_2 }}_handler_base_vseq_c  {{ mode_2 }}_handlers[$]; ///< Queue of handler Sequences that can respond to requests from {{ mode_1 }}
   // TODO Add state variables
   //      Ex: uvma_{{ name }}_{{ mode_1 }}_{{ segments[0].name }}_mon_trn_c  mon_outstanding_q[$]    ; ///< TODO Describe uvma_{{ name }}_cntxt_c::mon_outstanding_q
   //          uvma_{{ name }}_{{ mode_2 }}_{{ segments[0].name }}_mon_trn_c  drv_{{ mode_2 }}_outstanding_q[$]; ///< TODO Describe uvma_{{ name }}_cntxt_c::drv_{{ mode_2 }}_outstanding_q
   {% else %}// TODO Add state variables
   //      Ex: uvma_{{ name }}_word_b_t  drv_data_q[$]; ///< TODO Describe uvma_{{ name }}_cntxt_c::drv_data_q
   {% if duplex %}//          uvma_{{ name }}_{{ mode_1 }}_{{ segments[0].name }}_mon_trn_c  mon_{{ mode_1 }}_{{ segments[0].name }}_q[$]; ///< TODO Describe uvma_{{ name }}_cntxt_c::mon_{{ mode_1 }}_{{ segments[0].name }}_q
   //          uvma_{{ name }}_{{ mode_2 }}_{{ segments[1].name }}_mon_trn_c  mon_{{ mode_2 }}_{{ segments[1].name }}_q[$]; ///< TODO Describe uvma_{{ name }}_cntxt_c::mon_{{ mode_2 }}_{{ segments[1].name }}_q
   {% else %}//          uvma_{{ name }}_{{ mode_1 }}_{{ segments[0].name }}_mon_trn_c  mon_q[$]; ///< TODO Describe uvma_{{ name }}_cntxt_c::mon_q
{% endif %}{% endif %}   /// @}

   /// @name Sequences
   /// @{
   uvm_sequence_base  mon_vseq ; ///< Monitor Virtual Sequence instance.
   uvm_sequence_base  idle_vseq; ///< Idle Generating Virtual Sequence instance.
   uvm_sequence_base  {{ mode_1 }}_drv_vseq; ///< {{ mode_1.upper() }} Driver Virtual Sequence instance.
   uvm_sequence_base  {{ mode_2 }}_drv_vseq; ///< {{ mode_2.upper() }} Driver Virtual Sequence instance.
   /// @}


   `uvm_object_utils_begin(uvma_{{ name }}_cntxt_c)
      `uvm_field_enum(uvml_reset_state_enum, reset_state, UVM_DEFAULT)
      `uvm_field_event(sample_cfg_e  , UVM_DEFAULT)
      `uvm_field_event(sample_cntxt_e, UVM_DEFAULT)
      {% if mm %}`uvm_field_object(memory, UVM_DEFAULT)
   {% endif %}`uvm_object_utils_end


   /**
    * Builds objects.
    */
   extern function new(string name="uvma_{{ name }}_cntxt");

   /**
    * Returns all state variables to initial values.
    * Called by monitor (uvma_{{ name }}_mon_c) when it observes a reset pulse.
    */
   extern function void reset();

endclass : uvma_{{ name }}_cntxt_c


function uvma_{{ name }}_cntxt_c::new(string name="uvma_{{ name }}_cntxt");

   super.new(name);
   reset_state    = UVML_RESET_STATE_PRE_RESET;
   {% if mm %}memory         = uvml_ral_mem_model_c::type_id::create("memory");
   // TODO Create state variables
   //      Ex: {{ mode_1 }}_{{ segments[0].name }}_req_e = new("{{ mode_1 }}_{{ segments[0].name }}_req_e");
{% endif %}sample_cfg_e   = new("sample_cfg_e"  );
   sample_cntxt_e = new("sample_cntxt_e");

endfunction : new


function void uvma_{{ name }}_cntxt_c::reset();

   // TODO Reset state variables
   {% if mm %}//      Ex: mon_outstanding_q.delete();
   //          drv_{{ mode_2 }}_outstanding_q.delete();
   {% else %}//       Ex: drv_data_q.delete();
   {% if duplex %}//          mon_{{ mode_1 }}_{{ segments[0].name }}_q.delete();
   //          mon_{{ mode_1 }}_{{ segments[1].name }}_q.delete();
   //          mon_{{ mode_2 }}_{{ segments[0].name }}_q.delete();
   //          mon_{{ mode_2 }}_{{ segments[1].name }}_q.delete();
   {% else %}//          mon_{{ mode_1 }}_q.delete();
   //          mon_{{ mode_2 }}_q.delete();
{% endif %}{% endif %}
endfunction : reset


`endif // __UVMA_{{ name.upper() }}_CNTXT_SV__
