// Copyright {{ year }} {{ name_of_copyright_owner }}
// {{ license }}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


`ifndef __UVMA_{{ name.upper() }}_MON_TRN_SV__
`define __UVMA_{{ name.upper() }}_MON_TRN_SV__


/**
 * Monitor Transaction rebuilt by the Monitor Virtual Sequence (uvma_{{ name }}_mon_vseq_c).
 * Analog of uvma_{{ name }}_seq_item_c.
 * @ingroup uvma_{{ name }}_obj
 */
class uvma_{{ name }}_mon_trn_c extends uvml_mon_trn_c;

   uvma_{{ name }}_cfg_c  cfg; ///< Agent configuration handle

   /// @name Data
   /// @{
   int unsigned  data_size; ///< Size of #data
   uvma_{{ name }}_word_l_t  data[]; ///< Payload Data
   // TODO Add data fields
   //      Ex: uvma_{{ name }}_user_l_t  user; ///< User Data
   /// @}

   /// @name Metadata
   /// @{
   int unsigned  gnt_latency; ///< Number of cycles before gnt is asserted
   /// @}


   `uvm_object_utils_begin(uvma_{{ name }}_mon_trn_c)
      `uvm_field_int(data_size, UVM_DEFAULT + UVM_DEC + UVM_NOPACK)
      `uvm_field_array_int(data, UVM_DEFAULT)
   `uvm_object_utils_end


   /**
    * Default constructor.
    */
   extern function new(string name="uvma_{{ name }}_mon_trn");

   /**
    * Describes transaction as metadata for uvml_logs_metadata_logger_c.
    */
   extern virtual function uvml_metadata_t get_metadata();

endclass : uvma_{{ name }}_mon_trn_c


function uvma_{{ name }}_mon_trn_c::new(string name="uvma_{{ name }}_mon_trn");

   super.new(name);

endfunction : new


function uvml_metadata_t uvma_{{ name }}_mon_trn_c::get_metadata();

   string        data_size_str, data_str;
   int unsigned  field_count = 0;
   data_size_str = $sformatf("%0d", data_size);
   get_metadata.push_back('{
      index     : field_count,
      value     : data_size_str,
      col_name  : "size",
      col_width : data_size_str.len(),
      col_align : UVML_TEXT_ALIGN_RIGHT,
      data_type : UVML_FIELD_INT
   });
   field_count++;
   data_str = $sformatf("%h%h ... %h%h", data[data_size-1], data[data_size-2], data[1], data[0]);
   get_metadata.push_back('{
      index     : field_count,
      value     : data_str,
      col_name  : "data",
      col_width : data_str.len(),
      col_align : UVML_TEXT_ALIGN_RIGHT,
      data_type : UVML_FIELD_INT
   });
   field_count++;

endfunction : get_metadata


`endif // __UVMA_{{ name.upper() }}_MON_TRN_SV__
