// Copyright {{ year }} {{ name_of_copyright_owner }}
// {{ license }}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


`ifndef __UVMA_{{ name.upper() }}_{{ mode_2.upper() }}_DRV_VSEQ_SV__
`define __UVMA_{{ name.upper() }}_{{ mode_2.upper() }}_DRV_VSEQ_SV__


/**
 * Virtual Sequence implementing an event handler loop generating {{ mode_2.upper() }} Sequence Items to {{ mode_1.upper() }} requests.
 * @ingroup uvma_{{ name }}_seq
 */
class uvma_{{ name }}_{{ mode_2 }}_drv_vseq_c extends uvma_{{ name }}_base_vseq_c;

   `uvm_object_utils(uvma_{{ name }}_{{ mode_2 }}_drv_vseq_c)

   /**
    * Default constructor.
    */
   extern function new(string name="uvma_{{ name }}_{{ mode_2 }}_drv_vseq");

   /**
    * Forks off the `drive_x()` tasks and the response loop with a reset thread.
    */
   extern virtual task body();

{% for segment in segments %}   /**
    * Generates Sequence Items for uvma_{{ name }}_{{ mode_2 }}_drv_c.
    */
   extern virtual task drive_{{ segment.name }}();

{% endfor %}   /**
    * Response handler event loop.
    */
   extern virtual task response_loop();

{% for segment in segments %}   /**
    * Waits for the next {{ mode_2.upper() }} {{ segment.name.upper() }} Virtual Interface clock edge.
    */
   extern task wait_clk_{{ segment.name }}();

{% endfor %}endclass : uvma_{{ name }}_{{ mode_2 }}_drv_vseq_c


function uvma_{{ name }}_{{ mode_2 }}_drv_vseq_c::new(string name="uvma_{{ name }}_{{ mode_2 }}_drv_vseq");

   super.new(name);

endfunction : new


task uvma_{{ name }}_{{ mode_2 }}_drv_vseq_c::body();

   forever begin
      fork
         {% for segment in segments %}begin
            wait (cntxt.reset_state == UVML_RESET_STATE_POST_RESET);
            drive_{{ segment.name }}();
         end
         {% endfor %}begin
            wait (cntxt.reset_state == UVML_RESET_STATE_POST_RESET);
            response_loop();
         end
         begin
            wait (cntxt.reset_state == UVML_RESET_STATE_POST_RESET);
            wait (cntxt.reset_state != UVML_RESET_STATE_POST_RESET);
         end
      join_any
      disable fork;
   end

endtask : body


{% for segment in segments %}task uvma_{{ name }}_{{ mode_2 }}_drv_vseq_c::drive_{{ segment.name }}();

   wait_clk_{{ segment.name }}();
   // TODO Implement uvma_{{ name }}_{{ mode_2 }}_drv_vseq_c::drive_{{ segment.name }}()
   //      Ex: uvma_{{ name }}_{{ mode_2 }}_{{ segment.name }}_seq_item_c  {{ mode_2 }}_{{ segment.name }}_seq_item;
   //          forever begin
   //             if ($urandom_range(0,1)) begin
   //                `uvm_create_on({{ mode_2 }}_{{ segment.name }}_seq_item, p_sequencer.{{ mode_2 }}_{{ segment.name }}_sequencer)
   //                `uvm_rand_send_pri_with({{ mode_2 }}_{{ segment.name }}_seq_item, `UVMA_{{ name.upper() }}_{{ mode_2.upper() }}_DRV_SEQ_ITEM_PRI, {
   //                   {{ segment.name }}req == 1'b1;
   //                })
   //             end
   //             else begin
   //                wait_clk_{{ segment.name }}();
   //             end
   //          end

endtask : drive_{{ segment.name }}


{% endfor %}task uvma_{{ name }}_{{ mode_2 }}_drv_vseq_c::response_loop();

   uvma_{{ name }}_{{ mode_1 }}_{{ segments[0].name }}_mon_trn_c  trn;
   bit  handled = 0;
   forever begin
      wait_clk_{{ segments[0].name }}();
      // TODO Implement uvma_{{ name }}_{{ mode_2 }}_drv_vseq_c::response_loop()
      //      Ex: cntxt.{{ mode_1 }}_{{ segments[0].name }}_req_e.wait_trigger();
      //          while (cntxt.drv_{{ mode_2 }}_outstanding_q.size()) begin
      //             trn = cntxt.drv_{{ mode_2 }}_outstanding_q.pop_front();
      //             handled = 0;
      //             foreach (cntxt.{{ mode_2 }}_handlers[jj]) begin
      //                cntxt.{{ mode_2 }}_handlers[jj].handle_{{ mode_1 }}_req(trn, handled);
      //                if (handled) begin
      //                   break;
      //                end
      //             end
      //             if (!handled) begin
      //                `uvm_warning("{{ name.upper() }}_{{ mode_2.upper() }}_DRV_VSEQ", $sformatf("Request from '{{ mode_1.upper() }}' not handled:\n%s", trn.sprint()))
      //             end
      //          end
   end

endtask : response_loop


{% for segment in segments %}task uvma_{{ name }}_{{ mode_2 }}_drv_vseq_c::wait_clk_{{ segment.name }}();

   @(cntxt.vif.drv_{{ mode_2 }}_{{ segment.name }}_cb);

endtask : wait_clk_{{ segment.name }}


{% endfor %}`endif // __UVMA_{{ name.upper() }}_{{ mode_2.upper() }}_DRV_VSEQ_SV__
