// Copyright {{ year }} {{ name_of_copyright_owner }}
// {{ license }}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


`ifndef __UVMA_{{ name.upper() }}_{{ mode_2.upper() }}_HANDLER_MEM_VSEQ_SV__
`define __UVMA_{{ name.upper() }}_{{ mode_2.upper() }}_HANDLER_MEM_VSEQ_SV__


/**
 * Virtual Sequence implementing a {{ mode_2.upper() }} memory.
 * @ingroup uvma_{{ name }}_seq
 */
class uvma_{{ name }}_{{ mode_2 }}_handler_mem_vseq_c extends uvma_{{ name }}_{{ mode_2 }}_handler_base_vseq_c;

   `uvm_object_utils(uvma_{{ name }}_{{ mode_2 }}_handler_mem_vseq_c)

   /**
    * Default constructor.
    */
   extern function new(string name="uvma_{{ name }}_{{ mode_2 }}_handler_mem_vseq");

   /**
    * Performs memory operations and responds to {{ mode_1.upper() }} by generating {{ mode_2.upper() }} Sequence Items.
    */
   extern virtual task handle_{{ mode_1 }}_req(ref uvma_{{ name }}_{{ mode_1 }}_{{ segments[0].name }}_mon_trn_c trn, output bit handled);

endclass : uvma_{{ name }}_{{ mode_2 }}_handler_mem_vseq_c


function uvma_{{ name }}_{{ mode_2 }}_handler_mem_vseq_c::new(string name="uvma_{{ name }}_{{ mode_2 }}_handler_mem_vseq");

   super.new(name);

endfunction : new


task uvma_{{ name }}_{{ mode_2 }}_handler_mem_vseq_c::handle_{{ mode_1 }}_req(ref uvma_{{ name }}_{{ mode_1 }}_{{ segments[0].name }}_mon_trn_c trn, output bit handled);

   // TODO Implement uvma_{{ name }}_{{ mode_2 }}_handler_mem_vseq_c::handle_{{ mode_1 }}_req(){% if multisegment %}
   //      Ex: uvma_{{ name }}_data_b_t  readback_data ;
   //          uvma_{{ name }}_{{ mode_2 }}_{{ segments[1].name }}_seq_item_c  {{ mode_2 }}_{{ segments[1].name }}_seq_item;
   //          `uvm_info("{{ name.upper() }}_SLV_MEM_VSEQ", $sformatf("Responding to \n%s", trn.sprint()), UVM_DEBUG)
   //          do begin
   //             `uvm_create_on({{ mode_2 }}_{{ segments[1].name }}_seq_item, p_sequencer.{{ mode_2 }}_{{ segments[1].name }}_sequencer)
   //             if (trn.{{ segments[0].name }}we === 1'b1) begin
   //                mem_write(trn.{{ segments[0].name }}addr, trn.{{ segments[0].name }}data{% if sbe %}, trn.{{ segments[0].name }}be{% endif %});
   //             end
   //             else begin
   //                readback_data = mem_read(trn.{{ segments[0].name }}addr{% if sbe %}, trn.{{ segments[0].name }}be{% endif %});
   //                // TODO Fill {{ mode_2 }}_{{ segments[1].name }}_seq_item with readback_data
   //             end
   //             `uvm_send_pri({{ mode_2 }}_{{ segments[1].name }}_seq_item, `UVMA_{{ name.upper() }}_SLV_DRV_SEQ_ITEM_PRI)
   //          end while ({{ mode_2 }}_{{ segments[1].name }}_seq_item.{{ segments[1].name }}gnt !== 1'b1);
   //          `uvm_info("{{ name.upper() }}_SLV_MEM_VSEQ", $sformatf("Responded to \n%s\nwith\n%s", trn.sprint(), {{ mode_2 }}_{{ segments[1].name }}_seq_item.sprint()), UVM_DEBUG)
   //          handled = 1;
{% endif %}
endtask : handle_{{ mode_1 }}_req


`endif // __UVMA_{{ name.upper() }}_{{ mode_2.upper() }}_HANDLER_MEM_VSEQ_SV__
