// Copyright {{ year }} {{ name_of_copyright_owner }}
// {{ license }}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


`ifndef __UVMA_{{ name.upper() }}_MON_VSEQ_SV__
`define __UVMA_{{ name.upper() }}_MON_VSEQ_SV__


/**
 * Virtual Sequence taking in {{ mode_1.upper() }} & {{ mode_2.upper() }} Monitor Transactions and creating {{ full_name }} transactions (uvma_{{ name }}_mon_trn_c).
 * @ingroup uvma_{{ name }}_seq
 */
class uvma_{{ name }}_mon_vseq_c extends uvma_{{ name }}_base_vseq_c;

   `uvm_object_utils(uvma_{{ name }}_mon_vseq_c)

   /**
    * Default constructor.
    */
   extern function new(string name="uvma_{{ name }}_mon_vseq");

   /**
    * Infinite loop forking off the `monitor_x()` tasks and a reset thread.
    */
   extern virtual task body();

{% for segment in segments %}   /**
    * TODO Describe uvma_{{ name }}_mon_vseq_c::monitor_{{ segment.name }}()
    */
   extern task monitor_{{ segment.name }}();

{% endfor %}endclass : uvma_{{ name }}_mon_vseq_c


function uvma_{{ name }}_mon_vseq_c::new(string name="uvma_{{ name }}_mon_vseq");

   super.new(name);

endfunction : new


task uvma_{{ name }}_mon_vseq_c::body();

   `uvm_info("{{ name.upper() }}_MON_VSEQ", "Monitor virtual sequence has started", UVM_HIGH)
   return;// TODO Remove this line after uvma_{{ name }}_mon_vseq_c::monitor_x() tasks are implemented
   forever begin
      fork
{% for segment in segments %}         begin
            wait (cntxt.reset_state == UVML_RESET_STATE_POST_RESET);
            monitor_{{ segment.name }}();
         end
{% endfor %}         begin
            wait (cntxt.reset_state == UVML_RESET_STATE_POST_RESET);
            wait (cntxt.reset_state != UVML_RESET_STATE_POST_RESET);
         end
      join_any
      disable fork;
   end

endtask : body


{% for segment in segments %}task uvma_{{ name }}_mon_vseq_c::monitor_{{ segment.name }}();

{% if segment.name == segments[0].name %}   // TODO Implement uvma_{{ name }}_mon_vseq_c::monitor_{{ segment.name }}()
   //      Ex: uvma_{{ name }}_{{ segment.tx }}_{{ segment.name }}_mon_trn_c  {{ segment.tx }}_{{ segment.name }}_mon_trn;
   //          uvma_{{ name }}_{{ segment.rx }}_{{ segment.name }}_mon_trn_c  {{ segment.rx }}_{{ segment.name }}_mon_trn;
   //          forever begin
   //             do begin
   //                get_{{ segment.tx }}_{{ segment.name }}_mon_trn({{ segment.tx }}_{{ segment.name }}_mon_trn);
   //                get_{{ segment.rx }}_{{ segment.name }}_mon_trn({{ segment.rx }}_{{ segment.name }}_mon_trn );
   //             end while (({{ segment.tx }}_{{ segment.name }}_mon_trn.{{ segment.name }}req !== 1'b1) || ({{ segment.rx }}_{{ segment.name }}_mon_trn.{{ segment.name }}gnt !== 1'b1));
   //             cntxt.mon_outstanding_q.push_back({{ segment.tx }}_{{ segment.name }}_mon_trn);
   //             if (cfg.is_active && (cfg.drv_mode == UVMA_{{ name.upper() }}_DRV_MODE_{{ segment.rx.upper() }})) begin
   //                cntxt.drv_{{ segment.rx }}_outstanding_q.push_back({{ segment.tx }}_{{ segment.name }}_mon_trn);
   //             end
   //             do begin
   //                get_{{ segment.tx }}_{{ segment.name }}_mon_trn({{ segment.tx }}_{{ segment.name }}_mon_trn);
   //                get_{{ segment.rx }}_{{ segment.name }}_mon_trn({{ segment.rx }}_{{ segment.name }}_mon_trn );
   //             end while (({{ segment.tx }}_{{ segment.name }}_mon_trn.{{ segment.name }}req === 1'b1) && ({{ segment.rx }}_{{ segment.name }}_mon_trn.{{ segment.name }}gnt === 1'b1));
   //             if (cfg.is_active && (cfg.drv_mode == UVMA_{{ name.upper() }}_DRV_MODE_{{ segment.rx.upper() }})) begin
   //                cntxt.{{ segment.tx }}_{{ segment.name }}_req_e.trigger();
   //             end
   //             `uvml_hrtbt_owner(p_sequencer)
   //          end
{% else %}   // TODO Implement uvma_{{ name }}_mon_vseq_c::monitor_{{ segment.name }}()
   //      Ex: uvma_{{ name }}_mon_trn_c  mon_trn;
   //          uvma_{{ name }}_{{ segments[0].rx }}_{{ segments[0].name }}_mon_trn_c  {{ segments[0].rx }}_{{ segments[0].name }}_mon_trn;
   //          uvma_{{ name }}_{{ segments[0].rx }}_{{ segment.name }}_mon_trn_c  {{ segments[0].rx }}_{{ segment.name }}_mon_trn;
   //          uvma_{{ name }}_{{ segments[0].tx }}_{{ segment.name }}_mon_trn_c  {{ segments[0].tx }}_{{ segment.name }}_mon_trn;
   //
   //          forever begin
   //             do begin
   //                get_{{ segments[0].tx }}_{{ segment.name }}_mon_trn({{ segments[0].tx }}_{{ segment.name }}_mon_trn );
   //                get_{{ segments[0].rx }}_{{ segment.name }}_mon_trn({{ segments[0].rx }}_{{ segment.name }}_mon_trn);
   //             end while (({{ segments[0].tx }}_{{ segment.name }}_mon_trn.{{ segment.name }}req !== 1'b1) || ({{ segments[0].rx }}_{{ segment.name }}_mon_trn.{{ segment.name }}gnt !== 1'b1));
   //             {{ segments[0].rx }}_{{ segments[0].name }}_mon_trn = cntxt.mon_outstanding_q.pop_front();
   //             if ({{ segments[0].rx }}_{{ segments[0].name }}_mon_trn != null) begin
   //                mon_trn = uvma_{{ name }}_mon_trn_c::type_id::create("mon_trn");
   //                mon_trn.set_initiator({{ segments[0].rx }}_{{ segments[0].name }}_mon_trn.get_initiator());
   //                mon_trn.cfg = cfg;
   //                mon_trn.set_timestamp_start({{ segments[0].rx }}_{{ segments[0].name }}_mon_trn.get_timestamp_start());
   //                mon_trn.set_timestamp_end({{ segments[0].tx }}_{{ segment.name }}_mon_trn.get_timestamp_end());
   //                mon_trn.address = {{ segments[0].rx }}_{{ segments[0].name }}_mon_trn.{{ segment.name }}addr;
   //                {% if sbe %}mon_trn.be      = {{ segments[0].rx }}_a_mon_trn.{{ segment.name }}be  ;
   //                {% endif %}if ({{ segments[0].rx }}_{{ segments[0].name }}_mon_trn.{{ segment.name }}we) begin
   //                   mon_trn.data = {{ segments[0].rx }}_{{ segments[0].name }}_mon_trn.{{ segment.name }}data;
   //                   mon_trn.access_type = UVMA_{{ name.upper() }}_ACCESS_WRITE;
   //                end
   //                else begin
   //                   mon_trn.data = {{ segments[0].tx }}_{{ segment.name }}_mon_trn.rdata;
   //                   mon_trn.access_type = UVMA_{{ name.upper() }}_ACCESS_READ;
   //                end
   //             end
   //             else begin
   //                `uvm_error("{{ name.upper() }}_MON_VSEQ", $sformatf("No outstanding {{ segments[0].rx }}_{{ segments[0].name }} transaction to account for this {{ segments[0].tx }}_{{ segment.name }} transaction:\n%s", {{ segments[0].tx }}_{{ segment.name }}_mon_trn.sprint()))
   //             end
   //             `uvml_hrtbt_owner(p_sequencer)
   //             write_mon_trn(mon_trn);
   //          end
{% endif %}
endtask : monitor_{{ segment.name }}


{% endfor %}`endif // __UVMA_{{ name.upper() }}_MON_VSEQ_SV__
