// Copyright {{ year }} {{ name_of_copyright_owner }}
// {{ license }}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


`ifndef __UVMA_{{ name.upper() }}_MON_VSEQ_SV__
`define __UVMA_{{ name.upper() }}_MON_VSEQ_SV__


/**
 * Virtual Sequence taking in {{ mode_1.upper() }} & {{ mode_2.upper() }} Monitor Transactions and creating {{ full_name }} transactions (uvma_{{ name }}_mon_trn_c).
 * @ingroup uvma_{{ name }}_seq
 */
class uvma_{{ name }}_mon_vseq_c extends uvma_{{ name }}_base_vseq_c;

   `uvm_object_utils(uvma_{{ name }}_mon_vseq_c)

   /**
    * Default constructor.
    */
   extern function new(string name="uvma_{{ name }}_mon_vseq");

   /**
    * Infinite loop forking off the `monitor_x()` tasks and a reset thread.
    */
   extern virtual task body();

{% for segment in segments %}   /**
    * TODO Describe uvma_{{ name }}_mon_vseq_c::monitor_{{ segment.name }}()
    */
   extern virtual task monitor_{{ segment.name }}();

{% endfor %}endclass : uvma_{{ name }}_mon_vseq_c


function uvma_{{ name }}_mon_vseq_c::new(string name="uvma_{{ name }}_mon_vseq");

   super.new(name);

endfunction : new


task uvma_{{ name }}_mon_vseq_c::body();

   `uvm_info("{{ name.upper() }}_MON_VSEQ", "Monitor virtual sequence has started", UVM_HIGH)
   forever begin
      fork
{% for segment in segments %}         begin
            wait (cntxt.reset_state == UVML_RESET_STATE_POST_RESET);
            monitor_{{ segment.name }}();
         end
{% endfor %}         begin
            wait (cntxt.reset_state == UVML_RESET_STATE_POST_RESET);
            wait (cntxt.reset_state != UVML_RESET_STATE_POST_RESET);
         end
      join_any
      disable fork;
   end

endtask : body


{% for segment in segments %}task uvma_{{ name }}_mon_vseq_c::monitor_{{ segment.name }}();

   uvma_{{ name }}_mon_trn_c  mon_trn;
   uvma_{{ name }}_{{ segment.tx }}_{{ segment.name }}_mon_trn_c  {{ segment.tx }}_{{ segment.name }}_mon_trn;
   uvma_{{ name }}_{{ segment.rx }}_{{ segment.name }}_mon_trn_c  {{ segment.rx }}_{{ segment.name }}_mon_trn;
   uvma_{{ name }}_{{ segment.tx }}_{{ segment.name }}_mon_trn_c  current_trn;

   forever begin
      get_{{ segment.tx }}_{{ segment.name }}_mon_trn({{ segment.tx }}_{{ segment.name }}_mon_trn);
      get_{{ segment.rx }}_{{ segment.name }}_mon_trn({{ segment.rx }}_{{ segment.name }}_mon_trn);
      // TODO Implement uvma_{{ name }}_mon_vseq_c::monitor_{{ segment.name }}()
      //      Ex: uvma_{{ name }}_word_b_t  word_q[$];
      //          uvma_{{ name }}_word_b_t  packed_bytes[];
      //          do begin
      //             get_{{ segment.tx }}_{{ segment.name }}_mon_trn({{ segment.tx }}_{{ segment.name }}_mon_trn);
      //             get_{{ segment.rx }}_{{ segment.name }}_mon_trn({{ segment.rx }}_{{ segment.name }}_mon_trn);
      //          end while (({{ segment.tx }}_{{ segment.name }}_mon_trn.{{ segment.name }}_req !== 1'b1) || ({{ segment.rx }}_{{ segment.name }}_mon_trn.{{ segment.name }}_gnt !== 1'b1));
      //          do begin
      //             cntxt.mon_{{ segment.tx }}_{{ segment.name }}_q.push_back({{ segment.tx }}_{{ segment.name }}_mon_trn);
      //             get_{{ segment.tx }}_{{ segment.name }}_mon_trn({{ segment.tx }}_{{ segment.name }}_mon_trn);
      //             get_{{ segment.rx }}_{{ segment.name }}_mon_trn({{ segment.rx }}_{{ segment.name }}_mon_trn );
      //          end while (({{ segment.tx }}_{{ segment.name }}_mon_trn.{{ segment.name }}_req === 1'b1) && ({{ segment.rx }}_{{ segment.name }}_mon_trn.{{ segment.name }}_gnt === 1'b1));
      //          mon_trn = uvma_{{ name }}_mon_trn_c::type_id::create("mon_trn");
      //          mon_trn.set_timestamp_start(cntxt.mon_{{ segment.tx }}_{{ segment.name }}_q[0].get_timestamp_start());
      //          do begin
      //             current_trn = cntxt.mon_{{ segment.tx }}_{{ segment.name }}_q.pop_front();
      //             for (int unsigned ii=0; ii<cfg.data_width; ii++) begin
      //                word_q.push_back(current_trn.{{ segment.name }}_data[ii]);
      //             end
      //          end while (cntxt.mon_{{ segment.tx }}_{{ segment.name }}_q.size());
      //          packed_bytes = new[word_q.size()];
      //          for (int unsigned ii=0; ii<packed_bytes.size(); ii++) begin
      //             packed_bytes[ii] = word_q.pop_front();
      //          end
      //          void'(mon_trn.unpack_bytes(packed_bytes));
      //          mon_trn.set_timestamp_end(current_trn.get_timestamp_end());
      //          `uvml_hrtbt_owner(p_sequencer)
      //          write_{{ segment.name }}_mon_trn(mon_trn);
   end

endtask : monitor_{{ segment.name }}


{% endfor %}`endif // __UVMA_{{ name.upper() }}_MON_VSEQ_SV__
