// Copyright {{ year }} {{ name_of_copyright_owner }}
// {{ license }}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


`ifndef __UVMA_{{ name.upper() }}_{{ segment.tx.upper() }}_{{ segment.name.upper() }}_SEQ_ITEM_SV__
`define __UVMA_{{ name.upper() }}_{{ segment.tx.upper() }}_{{ segment.name.upper() }}_SEQ_ITEM_SV__


/**
 * Sequence Item created by {{ full_name }} Virtual Sequences for driving uvma_{{ name }}_{{ segment.tx }}_{{ segment.name }}_drv_c.
 * @ingroup uvma_{{ name }}_seq
 */
class uvma_{{ name }}_{{ segment.tx }}_{{ segment.name }}_seq_item_c extends uvml_seq_item_c;

   uvma_{{ name }}_cfg_c  cfg; ///< Agent configuration handle

   /// @name Data
   /// @{
   // TODO Add uvma_{{ name }}_{{ segment.tx }}_{{ segment.name }}_seq_item_c signals
   {% if mm %}//      Ex: rand uvma_{{ name }}_req_b_t   {{ segment.name }}req ; ///< TODO Describe uvma_{{ name }}_{{ segment.tx }}_{{ segment.name }}_seq_item_c::{{ segment.name }}req
   //          rand uvma_{{ name }}_we_b_t    {{ segment.name }}we  ; ///< TODO Describe uvma_{{ name }}_{{ segment.tx }}_{{ segment.name }}_seq_item_c::{{ segment.name }}we
   //          rand uvma_{{ name }}_addr_b_t  {{ segment.name }}addr; ///< TODO Describe uvma_{{ name }}_{{ segment.tx }}_{{ segment.name }}_seq_item_c::{{ segment.name }}addr
   {% if sbe %}//          rand uvma_{{ name }}_be_b_t    {{ segment.name }}be  ; ///< TODO Describe uvma_{{ name }}_{{ segment.tx }}_{{ segment.name }}_seq_item_c::{{ segment.name }}be
   {% endif %}//          rand uvma_{{ name }}_data_b_t  {{ segment.name }}data; ///< TODO Describe uvma_{{ name }}_{{ segment.tx }}_{{ segment.name }}_seq_item_c::{{ segment.name }}data
   {% else %}//      Ex: rand uvma_{{ name }}_req_b_t   {{ segment.name }}_req ; ///< TODO Describe uvma_{{ name }}_{{ segment.tx }}_{{ segment.name }}_seq_item_c::{{ segment.name }}_req
   //          rand uvma_{{ name }}_be_b_t    {{ segment.name }}_be  ; ///< TODO Describe uvma_{{ name }}_{{ segment.tx }}_{{ segment.name }}_seq_item_c::{{ segment.name }}_be
   //          rand uvma_{{ name }}_data_b_t  {{ segment.name }}_data; ///< TODO Describe uvma_{{ name }}_{{ segment.tx }}_{{ segment.name }}_seq_item_c::{{ segment.name }}_data
   {% endif %}/// @}

   /// @name Metadata
   /// @{
   // TODO Add uvma_{{ name }}_{{ segment.tx }}_{{ segment.name }}_seq_item_c metadata
   {% if mm %}//      Ex: uvma_{{ name }}_gnt_l_t  {{ segment.name }}gnt; ///< TODO Describe uvma_{{ name }}_{{ segment.tx }}_{{ segment.name }}_seq_item_c::{{ segment.name }}gnt
   {% else %}//      Ex: uvma_{{ name }}_gnt_l_t  {{ segment.name }}_gnt; ///< TODO Describe uvma_{{ name }}_{{ segment.tx }}_{{ segment.name }}_seq_item_c::{{ segment.name }}_gnt
{% endif %}/// @}


   `uvm_object_utils_begin(uvma_{{ name }}_{{ segment.tx }}_{{ segment.name }}_seq_item_c)
      // TODO Add `uvm_field_x macros
      {% if mm %}//      Ex: `uvm_field_int({{ segment.name }}req , UVM_DEFAULT              )
      //          `uvm_field_int({{ segment.name }}we  , UVM_DEFAULT              )
      //          `uvm_field_int({{ segment.name }}addr, UVM_DEFAULT + UVM_NOPRINT)
      {% if sbe %}//          `uvm_field_int({{ segment.name }}be  , UVM_DEFAULT + UVM_NOPRINT)
      {% endif %}//          `uvm_field_int({{ segment.name }}data, UVM_DEFAULT + UVM_NOPRINT)
      {% else %}//      Ex: `uvm_field_int({{ segment.name }}_req , UVM_DEFAULT              )
      //          `uvm_field_int({{ segment.name }}_be  , UVM_DEFAULT + UVM_NOPRINT)
      //          `uvm_field_int({{ segment.name }}_data, UVM_DEFAULT + UVM_NOPRINT)
{% endif %}   `uvm_object_utils_end


   /**
    * Default constructor.
    */
   extern function new(string name="uvma_{{ name }}_{{ segment.tx }}_{{ segment.name }}_seq_item");

   /**
    * Prints variable width fields.
    */
   extern function void do_print(uvm_printer printer);

   /**
    * Describes transaction as metadata for uvml_logs_metadata_logger_c.
    */
   extern function uvml_metadata_t get_metadata();

endclass : uvma_{{ name }}_{{ segment.tx }}_{{ segment.name }}_seq_item_c


function uvma_{{ name }}_{{ segment.tx }}_{{ segment.name }}_seq_item_c::new(string name="uvma_{{ name }}_{{ segment.tx }}_{{ segment.name }}_seq_item");

   super.new(name);

endfunction : new


function void uvma_{{ name }}_{{ segment.tx }}_{{ segment.name }}_seq_item_c::do_print(uvm_printer printer);

   super.do_print(printer);
   if (cfg == null) begin
      `uvm_warning("{{ name.upper() }}_{{ segment.tx.upper() }}_{{ segment.name.upper() }}_SEQ_ITEM", "cfg handle is null, skipping do_print()")
   end
   else begin
      // TODO Implement uvma_{{ name }}_{{ segment.tx }}_{{ segment.name }}_seq_item_c::do_print()
      {% if mm %}//      Ex: printer.print_field("{{ segment.name }}addr" , {{ segment.name }}addr, cfg.addr_width    );
      {% if sbe %}//          printer.print_field("{{ segment.name }}be"   , {{ segment.name }}be  , (cfg.data_width/8));
      {% endif %}//          printer.print_field("{{ segment.name }}data" , {{ segment.name }}data, cfg.data_width    );
      {% else %}//      Ex: printer.print_field("{{ segment.name }}_be"   , {{ segment.name }}_be  , (cfg.data_width/8));
      //          printer.print_field("{{ segment.name }}_data" , {{ segment.name }}_data, cfg.data_width    );
{% endif %}   end

endfunction : do_print


function uvml_metadata_t uvma_{{ name }}_{{ segment.tx }}_{{ segment.name }}_seq_item_c::get_metadata();

   // TODO Implement uvma_{{ name }}_{{ segment.tx }}_{{ segment.name }}_seq_item_c::get_metadata()
   //      Ex:
   {% if mm %}//          string  {{ segment.name }}we_str, {{ segment.name }}addr_str, {% if sbe %}{{ segment.name }}be_str, {% endif %}{{ segment.name }}data_str;
   {% else %}//          string  {{ segment.name }}_be_str, {{ segment.name }}_data_str;
   {% endif %}//          int unsigned  field_count = 0;
   //          if (cfg == null) begin
   //             `uvm_warning("{{ name.upper() }}_{{ segment.tx.upper() }}_{{ segment.name.upper() }}_SEQ_ITEM", "cfg handle is null, skipping get_metadata()")
   //          end
   //          else begin
   //             {% if mm %}if (({{ segment.name }}req === 1'b1) && ({{ segment.name }}gnt === 1'b1)) begin
   //                {{ segment.name }}we_str = ({{ segment.name }}we === 1'b1) ? "  W" : "R  ";
   //                get_metadata.push_back('{
   //                   index     : field_count,
   //                   value     : {{ segment.name }}we_str,
   //                   col_name  : "{{ segment.name }}we",
   //                   col_width : {{ segment.name }}we_str.len(),
   //                   col_align : UVML_TEXT_ALIGN_RIGHT,
   //                   data_type : UVML_FIELD_ENUM
   //                });
   //                field_count++;
   //                {{ segment.name }}addr_str = $sformatf("%h", {{ segment.name }}addr);
   //                {{ segment.name }}addr_str = {{ segment.name }}addr_str.substr({{ segment.name }}addr_str.len() - (cfg.addr_width/4), {{ segment.name }}addr_str.len()-1);
   //                get_metadata.push_back('{
   //                   index     : field_count,
   //                   value     : {{ segment.name }}addr_str,
   //                   col_name  : "{{ segment.name }}addr",
   //                   col_width : {{ segment.name }}addr_str.len(),
   //                   col_align : UVML_TEXT_ALIGN_RIGHT,
   //                   data_type : UVML_FIELD_ENUM
   //                });
   //                field_count++;
   //                {% if sbe %}{{ segment.name }}be_str = $sformatf("%b", {{ segment.name }}be);
   //                {{ segment.name }}be_str = {{ segment.name }}be_str.substr({{ segment.name }}be_str.len() - (cfg.data_width/8), {{ segment.name }}be_str.len()-1);
   //                get_metadata.push_back('{
   //                   index     : field_count,
   //                   value     : {{ segment.name }}be_str,
   //                   col_name  : "{{ segment.name }}be",
   //                   col_width : {{ segment.name }}be_str.len(),
   //                   col_align : UVML_TEXT_ALIGN_RIGHT,
   //                   data_type : UVML_FIELD_ENUM
   //                });
   //                field_count++;
   //                {% endif %}{{ segment.name }}data_str = $sformatf("%h", {{ segment.name }}data);
   //                {{ segment.name }}data_str = {{ segment.name }}data_str.substr({{ segment.name }}data_str.len() - (cfg.data_width/4), {{ segment.name }}data_str.len()-1);
   //                get_metadata.push_back('{
   //                   index     : field_count,
   //                   value     : {{ segment.name }}data_str,
   //                   col_name  : "{{ segment.name }}data",
   //                   col_width : {{ segment.name }}data_str.len(),
   //                   col_align : UVML_TEXT_ALIGN_RIGHT,
   //                   data_type : UVML_FIELD_INT
   //                });
   //                field_count++;
   //             {% else %}if (({{ segment.name }}_req === 1'b1) && ({{ segment.name }}_gnt === 1'b1)) begin
   //                {{ segment.name }}_be_str = $sformatf("%b", {{ segment.name }}_be);
   //                {{ segment.name }}_be_str = {{ segment.name }}_be_str.substr({{ segment.name }}_be_str.len() - (cfg.data_width/8), {{ segment.name }}_be_str.len()-1);
   //                get_metadata.push_back('{
   //                   index     : field_count,
   //                   value     : {{ segment.name }}_be_str,
   //                   col_name  : "{{ segment.name }}_be",
   //                   col_width : {{ segment.name }}_be_str.len(),
   //                   col_align : UVML_TEXT_ALIGN_RIGHT,
   //                   data_type : UVML_FIELD_ENUM
   //                });
   //                field_count++;
   //                {{ segment.name }}_data_str = $sformatf("%h", {{ segment.name }}_data);
   //                {{ segment.name }}_data_str = {{ segment.name }}_data_str.substr({{ segment.name }}_data_str.len() - (cfg.data_width/4), {{ segment.name }}_data_str.len()-1);
   //                get_metadata.push_back('{
   //                   index     : field_count,
   //                   value     : {{ segment.name }}_data_str,
   //                   col_name  : "{{ segment.name }}_data",
   //                   col_width : {{ segment.name }}_data_str.len(),
   //                   col_align : UVML_TEXT_ALIGN_RIGHT,
   //                   data_type : UVML_FIELD_INT
   //                });
   //                field_count++;
   //             {% endif %}end
   //          end

endfunction : get_metadata


`endif // __UVMA_{{ name.upper() }}_{{ segment.tx.upper() }}_{{ segment.name.upper() }}_SEQ_ITEM_SV__
