// Copyright {{ year }} {{ name_of_copyright_owner }}
// {{ license }}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


`ifndef __UVMA_{{ name.upper() }}_TDEFS_SV__
`define __UVMA_{{ name.upper() }}_TDEFS_SV__


{% for segment in segments %}typedef class uvma_{{ name }}_{{ segment.tx }}_{{ segment.name }}_mon_trn_c;
{% endfor %}


/// @name Logic vectors
/// @{
// TODO Add logic vectors
//      Ex: typedef logic  uvma_{{ name }}_req_l_t; ///< TODO Describe uvma_{{ name }}_req_l_t
//          typedef logic  uvma_{{ name }}_gnt_l_t; ///< TODO Describe uvma_{{ name }}_gnt_l_t
{% if not mm %}{% else %}//          typedef logic [(`UVMA_{{ name.upper() }}_DATA_MAX_WIDTH-1):0][7:0]  uvma_{{ name }}_data_l_t; ///< TODO Describe uvma_{{ name }}_data_l_t
{% endif %}{% if mm %}typedef logic [(`UVMA_{{ name.upper() }}_ADDR_MAX_WIDTH-1):0]  uvma_{{ name }}_addr_l_t; ///< Address logic vector
typedef logic [((`UVMA_{{ name.upper() }}_DATA_MAX_WIDTH/8)-1):0]  uvma_{{ name }}_be_l_t; ///< Byte Enabled logic vector
typedef logic [(`UVMA_{{ name.upper() }}_DATA_MAX_WIDTH-1):0]  uvma_{{ name }}_data_l_t; ///< Data logic vector
{% else %}typedef logic [(`UVMA_{{ name.upper() }}_DATA_MAX_WIDTH-1):0]  uvma_{{ name }}_be_l_t; ///< Byte Enabled logic vector
typedef logic [7:0]  uvma_{{ name }}_word_l_t; ///< Word for uvma_{{ name }}_mon_trn_c payload data.
{% endif %}/// @}

/// @name Bit vectors
/// @{
// TODO Add bit vectors
//      Ex: typedef bit  uvma_{{ name }}_req_b_t; ///< TODO Describe uvma_{{ name }}_req_b_t
//          typedef bit  uvma_{{ name }}_gnt_b_t; ///< TODO Describe uvma_{{ name }}_gnt_b_t
{% if not mm %}{% else %}//          typedef bit [(`UVMA_{{ name.upper() }}_DATA_MAX_WIDTH-1):0][7:0]  uvma_{{ name }}_data_b_t; ///< TODO Describe uvma_{{ name }}_data_b_t
{% endif %}{% if mm %}typedef bit [(`UVMA_{{ name.upper() }}_ADDR_MAX_WIDTH-1):0]  uvma_{{ name }}_addr_b_t; ///< Address bit vector
typedef bit [((`UVMA_{{ name.upper() }}_DATA_MAX_WIDTH/8)-1):0]  uvma_{{ name }}_be_b_t; ///< Byte Enabled bit vector
typedef bit [(`UVMA_{{ name.upper() }}_DATA_MAX_WIDTH-1):0]  uvma_{{ name }}_data_b_t; ///< Data bit vector
{% else %}typedef bit [(`UVMA_{{ name.upper() }}_DATA_MAX_WIDTH-1):0]  uvma_{{ name }}_be_b_t; ///< Byte Enabled bit vector
typedef bit [7:0]  uvma_{{ name }}_word_b_t; ///< Word for uvma_{{ name }}_mon_trn_c payload data.
{% endif %}/// @}


{% if mm %}/**
 * Access types.
 */
typedef enum bit {
   UVMA_{{ name.upper() }}_ACCESS_READ  = 0, ///< TODO Describe UVMA_{{ name.upper() }}_ACCESS_READ
   UVMA_{{ name.upper() }}_ACCESS_WRITE = 1  ///< TODO Describe UVMA_{{ name.upper() }}_ACCESS_WRITE
} uvma_{{ name }}_access_enum;

{% endif %}
/**
 * Driving modes for uvma_{{ name }}_agent_c when active.
 */
typedef enum {
   UVMA_{{ name.upper() }}_DRV_MODE_{{ mode_1.upper() }}, ///< Drives {{ mode_1.upper() }}
   UVMA_{{ name.upper() }}_DRV_MODE_{{ mode_2.upper() }}  ///< Drives {{ mode_2.upper() }}
} uvma_{{ name }}_mode_enum;

/**
 * Driving modes for uvma_{{ name }}_idle_vseq_c.
 */
typedef enum {
   UVMA_{{ name.upper() }}_DRV_IDLE_ZEROS , //< Fills signals with 0's.
   UVMA_{{ name.upper() }}_DRV_IDLE_RANDOM  //< Fills signals with random data.
} uvma_{{ name }}_drv_idle_enum;


`endif // __UVMA_{{ name.upper() }}_TDEFS_SV__
