// Copyright {{ year }} {{ name_of_copyright_owner }}
// {{ license }}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


`ifndef __UVME_{{ name.upper() }}_ST_FULL_REG_SV__
`define __UVME_{{ name.upper() }}_ST_FULL_REG_SV__


/**
 * Mock 32-bit Register with only a single 32-bit Register Field.
 * @ingroup uvme_{{ name }}_st_reg
 */
class uvme_{{ name }}_st_full_reg_c extends uvml_ral_reg_c;

   rand uvm_reg_field  full; ///< 32-bit wide Mock Register Field.


   `uvm_object_utils_begin(uvme_{{ name }}_st_full_reg_c)
      `uvm_field_object(full, UVM_DEFAULT)
   `uvm_object_utils_end


   /**
    * Default constructor.
    */
   extern function new(string name="uvme_{{ name }}_st_full_reg", int unsigned n_bits=32, int has_coverage=UVM_NO_COVERAGE);

   /**
    * Creates and configures Register Fields.
    */
   extern function void build();

endclass : uvme_{{ name }}_st_full_reg_c


function uvme_{{ name }}_st_full_reg_c::new(string name="uvme_{{ name }}_st_full_reg", int unsigned n_bits=32, int has_coverage=UVM_NO_COVERAGE);

   super.new(name, n_bits, has_coverage);

endfunction : new


function void uvme_{{ name }}_st_full_reg_c::build();

   full = uvm_reg_field::type_id::create("full");
   full.configure(
      .parent                 (this),
      .size                   (  32),
      .lsb_pos                (   0),
      .access                 ("RW"),
      .volatile               (   0),
      .reset                  (   0),
      .has_reset              (   1),
      .is_rand                (   1),
      {% if sbe %}.individually_accessible(   1)
      {% else %}.individually_accessible(   0)
{% endif %}   );

endfunction: build


`endif // __UVME_{{ name.upper() }}_ST_FULL_REG_SV__
