// Copyright {{ year }} {{ name_of_copyright_owner }}
// {{ license }}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


`ifndef __UVME_{{ name.upper() }}_ST_REG_BLOCK_SV__
`define __UVME_{{ name.upper() }}_ST_REG_BLOCK_SV__


`include "uvme_{{ name }}_st_full_reg.sv"
`include "uvme_{{ name }}_st_split_reg.sv"


/**
 * Mock 32-bit Register Block for testing uvma_{{ name }}_reg_adapter_c.
 * @ingroup uvme_{{ name }}_st_reg
 */
class uvme_{{ name }}_st_reg_block_c extends uvml_ral_reg_block_c;

   rand uvme_{{ name }}_st_full_reg_c   full ; ///< Full Register.
   rand uvme_{{ name }}_st_split_reg_c  split; ///< Split Register.


   `uvm_object_utils_begin(uvme_{{ name }}_st_reg_block_c)
      `uvm_field_object(full , UVM_DEFAULT)
      `uvm_field_object(split, UVM_DEFAULT)
   `uvm_object_utils_end


   /**
    * Default constructor.
    */
   extern function new(string name="uvme_{{ name }}_st_reg_block", int has_coverage=UVM_NO_COVERAGE);

   /**
    * Creates Register(s).
    */
   extern virtual function void create_regs();

   /**
    * Creates default Register map.
    */
   extern virtual function void create_reg_map();

   /**
    * Adds Register(s) to Register map.
    */
   extern virtual function void add_regs_to_map();

endclass : uvme_{{ name }}_st_reg_block_c


function uvme_{{ name }}_st_reg_block_c::new(string name="uvme_{{ name }}_st_reg_block", int has_coverage=UVM_NO_COVERAGE);

   super.new(name, has_coverage);

endfunction : new


function void uvme_{{ name }}_st_reg_block_c::create_regs();

   full = uvme_{{ name }}_st_full_reg_c::type_id::create("full");
   full.configure(this);
   full.build();
   split = uvme_{{ name }}_st_split_reg_c::type_id::create("split");
   split.configure(this);
   split.build();

endfunction : create_regs


function void uvme_{{ name }}_st_reg_block_c::create_reg_map();

   default_map = create_map(
      .name     ("default_map"),
      .base_addr(base_address),
      .n_bytes  (4),
      .endian   (UVM_LITTLE_ENDIAN)
   );

endfunction : create_reg_map


function void uvme_{{ name }}_st_reg_block_c::add_regs_to_map();

   default_map.add_reg(
      .rg    (full),
      .offset(32'h00_00_00_00),
      .rights("RW")
   );
   default_map.add_reg(
      .rg    (split),
      .offset(32'h00_00_00_04),
      .rights("RW")
   );

endfunction : add_regs_to_map


`endif // _UVME_{{ name.upper() }}_ST_REG_BLOCK_SV__
