// Copyright {{ year }} {{ name_of_copyright_owner }}
// {{ license }}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


`ifndef __UVME_{{ name.upper() }}_ST_SPLIT_REG_SV__
`define __UVME_{{ name.upper() }}_ST_SPLIT_REG_SV__


/**
 * Mock 32-bit Register with many Register fields of different sizes.  Some non-byte aligned.
 * @ingroup uvme_{{ name }}_st_reg
 */
class uvme_{{ name }}_st_split_reg_c extends uvml_ral_reg_c;

   rand uvm_reg_field  abc; ///< 2 bytes
   rand uvm_reg_field  def; ///< 1 bytes
   rand uvm_reg_field  ghi; ///< 4 bits
   rand uvm_reg_field  jkl; ///< 2 bits
   rand uvm_reg_field  mno; ///< 1 bits
   rand uvm_reg_field  pqr; ///< 1 bits


   `uvm_object_utils_begin(uvme_{{ name }}_st_split_reg_c)
      `uvm_field_object(abc, UVM_DEFAULT)
      `uvm_field_object(def, UVM_DEFAULT)
      `uvm_field_object(ghi, UVM_DEFAULT)
      `uvm_field_object(jkl, UVM_DEFAULT)
      `uvm_field_object(mno, UVM_DEFAULT)
      `uvm_field_object(pqr, UVM_DEFAULT)
   `uvm_object_utils_end


   /**
    * Default constructor.
    */
   extern function new(string name="uvme_{{ name }}_st_split_reg", int unsigned n_bits=32, int has_coverage=UVM_NO_COVERAGE);

   /**
    * Creates and configures register fields.
    */
   extern function void build();

endclass : uvme_{{ name }}_st_split_reg_c


function uvme_{{ name }}_st_split_reg_c::new(string name="uvme_{{ name }}_st_split_reg", int unsigned n_bits=32, int has_coverage=UVM_NO_COVERAGE);

   super.new(name, n_bits, has_coverage);

endfunction : new


function void uvme_{{ name }}_st_split_reg_c::build();

   abc = uvm_reg_field::type_id::create("abc");
   abc.configure(
      .parent                 (this),
      .size                   (  16),
      .lsb_pos                (   0),
      .access                 ("RW"),
      .volatile               (   0),
      .reset                  (   0),
      .has_reset              (   1),
      .is_rand                (   1),
      {% if sbe %}.individually_accessible(   1)
      {% else %}.individually_accessible(   0)
{% endif %}   );
   def = uvm_reg_field::type_id::create("def");
   def.configure(
      .parent                 (this),
      .size                   (   8),
      .lsb_pos                (  16),
      .access                 ("RW"),
      .volatile               (   0),
      .reset                  (   0),
      .has_reset              (   1),
      .is_rand                (   1),
      {% if sbe %}.individually_accessible(   1)
      {% else %}.individually_accessible(   0)
{% endif %}   );
   ghi = uvm_reg_field::type_id::create("ghi");
   ghi.configure(
      .parent                 (this),
      .size                   (   4),
      .lsb_pos                (  24),
      .access                 ("RW"),
      .volatile               (   0),
      .reset                  (   0),
      .has_reset              (   1),
      .is_rand                (   1),
      .individually_accessible(   0)
   );
   jkl = uvm_reg_field::type_id::create("jkl");
   jkl.configure(
      .parent                 (this),
      .size                   (   2),
      .lsb_pos                (  28),
      .access                 ("RW"),
      .volatile               (   0),
      .reset                  (   0),
      .has_reset              (   1),
      .is_rand                (   1),
      .individually_accessible(   0)
   );
   mno = uvm_reg_field::type_id::create("mno");
   mno.configure(
      .parent                 (this),
      .size                   (   1),
      .lsb_pos                (  30),
      .access                 ("RW"),
      .volatile               (   0),
      .reset                  (   0),
      .has_reset              (   1),
      .is_rand                (   1),
      .individually_accessible(   0)
   );
   pqr = uvm_reg_field::type_id::create("pqr");
   pqr.configure(
      .parent                 (this),
      .size                   (   1),
      .lsb_pos                (  31),
      .access                 ("RW"),
      .volatile               (   0),
      .reset                  (   0),
      .has_reset              (   1),
      .is_rand                (   1),
      .individually_accessible(   0)
   );

endfunction: build


`endif // __UVME_{{ name.upper() }}_ST_SPLIT_REG_SV__
