// Copyright {{ year }} {{ name_of_copyright_owner }}
// {{ license }}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


`ifndef __UVME_{{ name.upper() }}_ST_REG_VSEQ_SV__
`define __UVME_{{ name.upper() }}_ST_REG_VSEQ_SV__


/**
 * Virtual Sequence running uvm_reg_bit_bash_seq on #cfg.reg_block.
 * @ingroup uvme_{{ name }}_st_seq
 */
class uvme_{{ name }}_st_reg_vseq_c extends uvme_{{ name }}_st_base_vseq_c;

   /// @name Sequences
   /// @{
   rand uvm_reg_bit_bash_seq  bit_bash_seq; ///< Sequence to be run.
   /// @}


   `uvm_object_utils_begin(uvme_{{ name }}_st_reg_vseq_c)
      `uvm_field_object(bit_bash_seq, UVM_DEFAULT)
   `uvm_object_utils_end


   /**
    * Creates #bit_bash_seq.
    */
   extern function new(string name="uvme_{{ name }}_st_reg_vseq");

   /**
    * Starts #bit_bash_seq.
    */
   extern virtual task body();

endclass : uvme_{{ name }}_st_reg_vseq_c


function uvme_{{ name }}_st_reg_vseq_c::new(string name="uvme_{{ name }}_st_reg_vseq");

   super.new(name);
   bit_bash_seq = uvm_reg_bit_bash_seq::type_id::create("bit_bash_seq");

endfunction : new


task uvme_{{ name }}_st_reg_vseq_c::body();

   bit_bash_seq.model = cfg.reg_block;
   bit_bash_seq.start(p_sequencer.{{ mode_1 }}_vsequencer);

endtask : body


`endif // __UVME_{{ name.upper() }}_ST_REG_VSEQ_SV__
