// Copyright {{ year }} {{ name_of_copyright_owner }}
// {{ license }}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


`ifndef __UVME_{{ name.upper() }}_ST_VSEQ_LIB_SV__
`define __UVME_{{ name.upper() }}_ST_VSEQ_LIB_SV__


`include "uvme_{{ name }}_st_base_vseq.sv"
`include "uvme_{{ name }}_st_rand_stim_vseq.sv"
{% if mm %}`include "uvme_{{ name }}_st_reg_vseq.sv"
{% endif %}

/**
 * Virtual Sequence Library containing Sequences for {{ full_name }} UVM Agent Self-Test Environment.
 * @ingroup uvme_{{ name }}_st_seq
 */
class uvme_{{ name }}_st_vseq_lib_c extends uvml_seq_lib_c #(
   .REQ(uvm_sequence_item),
   .RSP(uvm_sequence_item)
);

   `uvm_object_utils          (uvme_{{ name }}_st_vseq_lib_c)
   `uvm_sequence_library_utils(uvme_{{ name }}_st_vseq_lib_c)

   /**
    * 1. Initializes sequence library
    * 2. Adds sequences to library
    */
   extern function new(string name="uvme_{{ name }}_st_vseq_lib");

endclass : uvme_{{ name }}_st_vseq_lib_c


function uvme_{{ name }}_st_vseq_lib_c::new(string name="uvme_{{ name }}_st_vseq_lib");

   super.new(name);
   init_sequence_library();
   add_sequence(uvme_{{ name }}_st_rand_stim_vseq_c::get_type());
{% if mm %}   add_sequence(uvme_{{ name }}_st_reg_vseq_c::get_type());
{% endif %}
endfunction : new


`endif // __UVME_{{ name.upper() }}_ST_VSEQ_LIB_SV__
