// Copyright {{ year }} {{ name_of_copyright_owner }}
// {{ license }}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


`ifndef __UVMT_{{ name.upper() }}_ST_REG_TEST_SV__
`define __UVMT_{{ name.upper() }}_ST_REG_TEST_SV__


/**
 * Test running uvme_{{ name }}_st_reg_test_vseq_c with default parameters and Scoreboarding enabled.
 * @ingroup uvmt_{{ name }}_st_tests
 */
class uvmt_{{ name }}_st_reg_test_c extends uvmt_{{ name }}_st_base_test_c;

   rand uvme_{{ name }}_st_reg_vseq_c  reg_vseq; ///< Virtual Sequence run during #main_phase()


   `uvm_component_utils(uvmt_{{ name }}_st_reg_test_c)


   /**
    * Creates reg_vseq.
    */
   extern function new(string name="uvmt_{{ name }}_st_reg_test", uvm_component parent=null);

   /**
    * Runs reg_vseq on vsequencer.
    */
   extern virtual task main_phase(uvm_phase phase);

endclass : uvmt_{{ name }}_st_reg_test_c


function uvmt_{{ name }}_st_reg_test_c::new(string name="uvmt_{{ name }}_st_reg_test", uvm_component parent=null);

   super.new(name, parent);
   reg_vseq = uvme_{{ name }}_st_reg_vseq_c::type_id::create("reg_vseq");

endfunction : new


task uvmt_{{ name }}_st_reg_test_c::main_phase(uvm_phase phase);

   super.main_phase(phase);
   phase.raise_objection(this);
   `uvm_info("TEST", $sformatf("Starting reg virtual sequence:\n%s", reg_vseq.sprint()), UVM_NONE)
   reg_vseq.start(vsequencer);
   `uvm_info("TEST", $sformatf("Finished reg virtual sequence:\n%s", reg_vseq.sprint()), UVM_NONE)
   phase.drop_objection(this);

endtask : main_phase


`endif // __UVMT_{{ name.upper() }}_ST_REG_TEST_SV__
