# Hello from your Code Generator!
Thank you for using the Moore.io Advanced UVM Agent Code Template for Serial protocols v1.0!

Your parameters are:
* Name: '{{ name }}'
* Full Name: '{{ full_name }}'
* Mode 1: '{{ mode_1 }}'
* Mode 2: '{{ mode_2 }}'
* Direction 1: '{{ tx }}'
* Direction 2: '{{ rx }}'
* Clocking: {% if ddr %}DDR{% else %}SDR{% endif %}
* Interface Symmetry: {% if symmetric %}{{ tx.upper() }} and {{ rx.upper() }} are the same{% else %}{{ tx.upper() }} and {{ rx.upper() }} are NOT the same{% endif %}

If this is incorrect, it's recommended to delete the generated IP and re-generate with the correct parameters.

What follows is a short guide for developers of this new UVM Agent Self-Test Environment.

## 1. Modify the logical transaction definition
1. - [ ] Predictor - `comps/uvme_{{ name }}_st_prd_c` - Finish the Sequence Item -> Monitor Transaction conversion to match protocol frame definition.
2. - [ ] Scoreboard Logs - `obj/uvme_{{ name }}_st_cfg_c` - Add Monitor Transaction metadata to scoreboard logs by following the examples.


## Have fun!
The codebase is ready to test using the other 2 IPs generated along with this environment:
* `uvma_{{ name }}`
* `uvme_{{ name }}_st`


# {{ name_of_copyright_owner }} {{ full_name }} UVM Agent Self-Test Environment

# About
This IP contains the {{ name_of_copyright_owner }} {{ full_name }} UVM Agent Self-Test Environment.

# Block Diagram
![alt text](./docs/env_block_diagram.svg "{{ full_name }} UVM Agent Self-Test Environment")

# Directory Structure
* `bin` - Scripts, metadata and other miscellaneous files
* `docs` - Documents describing the {{ full_name }} UVM Agent Self-Test Environment
* `examples` - Code samples for using and extending this environment
* `src` - Source code


# Dependencies
It is dependent on the following IP:

* `uvm`
* `uvml`
* `uvml_logs`
* `uvma_{{ name }}`
