# Hello from your Code Generator!
Thank you for using the Moore.io Advanced UVM Agent Code Template for Serial protocols v1.0!

Your parameters are:
* Name: '{{ name }}'
* Full Name: '{{ full_name }}'
* Mode 1: '{{ mode_1 }}'
* Mode 2: '{{ mode_2 }}'
* Direction 1: '{{ tx }}'
* Direction 2: '{{ rx }}'
* Clocking: {% if ddr %}DDR{% else %}SDR{% endif %}
* Interface Symmetry: {% if symmetric %}{{ tx.upper() }} and {{ rx.upper() }} are the same{% else %}{{ tx.upper() }} and {{ rx.upper() }} are NOT the same{% endif %}

If this is incorrect, it is recommended to delete the generated IP and re-generate with the correct parameters.

What follows is a short guide for developers of this new UVM Agent Self-Test Bench.

## 1. Modify the physical interface
 1. - [ ] DUT Wrapper - `tb/uvmt_{{ name }}_st_dut_wrap.sv` - Modify the signals and connections to match your protocol's physical interface.

## Have fun!
The codebase is ready to test using the other 2 IPs generated along with this test bench:
* `uvme_{{ name }}_st`
* `uvmt_{{ name }}_st`




# {{ name_of_copyright_owner }} {{ full_name }} UVM Agent Self-Test Bench

# About
This IP contains the {{ name_of_copyright_owner }} {{ full_name }} UVM Agent Self-Test Bench.

# Block Diagram
![alt text](./docs/tb_block_diagram.svg "{{ full_name }} UVM Agent Self-Test Bench")

# Directory Structure
* `bin` - Scripts, metadata and other miscellaneous files
* `docs` - Documents describing the {{ full_name }} UVM Agent Self-Test Bench
* `examples` - Code samples for extending this Test Bench
* `src` - Source code


# Dependencies
It is dependent on the following IP:

* `uvm`
* `uvml`
* `uvml_logs`
* `uvma_{{ name }}`
* `uvme_{{ name }}_st`
