// Copyright {{ year }} {{ name_of_copyright_owner }}
// {{ license }}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


`ifndef __UVME_{{ name_uppercase }}_ST_CNTXT_SV__
`define __UVME_{{ name_uppercase }}_ST_CNTXT_SV__


/**
 * Object encapsulating all state variables for {{ name_normal_case }} UVM Library Self-Test Environment (uvme_{{ name }}_st_env_c) components.
 * @ingroup uvma_{{ name }}_st_obj
 */
class uvme_{{ name }}_st_cntxt_c extends uvml_cntxt_c;

   /// @name Objects
   /// @{
   uvm_event  sample_cfg_e  ; ///< Triggers sampling of configuration by the functional coverage model.
   uvm_event  sample_cntxt_e; ///< Triggers sampling of context by the functional coverage model.
   /// @}


   `uvm_object_utils_begin(uvme_{{ name }}_st_cntxt_c)
      `uvm_field_event(sample_cfg_e  , UVM_DEFAULT)
      `uvm_field_event(sample_cntxt_e, UVM_DEFAULT)
   `uvm_object_utils_end


   /**
    * Creates sub-context objects.
    */
   extern function new(string name="uvme_{{ name }}_st_cntxt");

   /**
    * Forces all sub-context objects to reset.
    */
   extern function void reset();

endclass : uvme_{{ name }}_st_cntxt_c


function uvme_{{ name }}_st_cntxt_c::new(string name="uvme_{{ name }}_st_cntxt");

   super.new(name);
   sample_cfg_e   = new("sample_cfg_e"  );
   sample_cntxt_e = new("sample_cntxt_e");

endfunction : new


function void uvme_{{ name }}_st_cntxt_c::reset();



endfunction : reset


`endif // __UVME_{{ name_uppercase }}_ST_CNTXT_SV__
