@page quick_start_guide Quick Start Guide
@htmlonly
<div class="autonumbering">
@endhtmlonly



@tableofcontents



@section quick_start_license_agreement License Agreement
© Copyright {{ year }} {{ name_of_copyright_owner }}

{{ license }}



@section quick_start_guide_id Document Information
ID | Name | Version
-- | ---- | -------
001 | Quick Start Guide | v.1.0


@subsection quick_start_guide_description Description
This document is a short guide to running the {{ name_normal_case }} UVM Library in its own Self-Test Bench.



@section quick_start_guide_revision_history Revision History
Revision  | Date | Description
--------- | ---- | -----------
1.0 | {{ year }}/01/01 | Initial Version



@section quick_start_guide_definitions Definitions
Symbol | Definition
------ | ----------
 'PDM' | Please Define Me



@section quick_start_guide_prerequisites Pre-Requisites
The Moore.io Client CLI, used throughout this tutorial is available via "pipx":
@code{.sh}pipx install mio-client@endcode



@section quick_start_guide_introduction Introduction
The {{ name_normal_case }} UVM Library has a Self-Test Bench pair used to verify the former thoroughly against itself.
This guide will walk you through running a sample test.



@section quick_start_guide_installation Installation
1. Install the {{ name_normal_case }} UVM Library: @code{.sh}mio install uvml_{{ name }}@endcode
3. Install the {{ name_normal_case }} UVM Library Self-Test Bench: @code{.sh}mio install uvmt_{{ name }}_st@endcode


@section quick_start_guide_compile_elaborate Compile and Elaborate
1. Compile the {{ name_normal_case }} UVM Library Self-Test Test Bench: @code{.sh}mio sim uvmt_{{ name }}_st -C@endcode
2. Elaborate the {{ name_normal_case }} UVM Library Self-Test Test Bench with wave capture enabled: @code{.sh}mio sim uvmt_{{ name }}_st -E -w@endcode


@section quick_start_guide_simulate Simulate
Launch {{ name_normal_case }} UVM Library Self-Test UVM Test "rand_stim" with seed "1":
@code{.sh}mio sim uvmt_{{ name }}_st -S -t rand_stim -s 1@endcode



@section quick_start_guide_results Results
The Moore.io CLI will printout the commands to view both the simulation logs (don't forget to check out the "trn_log"
directory for transaction logs) and waveforms.



@section quick_start_guide_conclusion Conclusion
That's all for this short guide.  For more information, including integration, have a look at the @subpage user_guide "User Guide".



@htmlonly
</div>
@endhtmlonly
