// Copyright {{ year }} {{ name_of_copyright_owner }}
// {{ license }}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


`ifndef __UVMT_{{ name_uppercase }}_ST_PKG_SV__
`define __UVMT_{{ name_uppercase }}_ST_PKG_SV__


// Doxygen Groups
/**
 * @defgroup uvmt_{{ name }}_st_pkg {{ name_normal_case }} UVM Library Self-Test Bench
 * @{
 * @defgroup uvmt_{{ name }}_st_misc   Miscellaneous
 * @defgroup uvmt_{{ name }}_st_tb     Test Bench
 * @defgroup uvmt_{{ name }}_st_tests  Tests
 * @}
 */


// Pre-processor macros
`include "uvm_macros.svh"
`include "uvml_macros.svh"
`include "uvml_logs_macros.svh"
`include "uvml_sb_macros.svh"
`include "uvml_{{ name }}_macros.svh"
`include "uvme_{{ name }}_st_macros.svh"
`include "uvmt_{{ name }}_st_macros.svh"

// Time units and precision for this test bench
timeunit       1ns;
timeprecision  1ps;

// Interface(s)
`include "uvmt_{{ name }}_st_clknrst_gen_if.sv"


/**
 * Encapsulates the test library of the {{ name_normal_case }} UVM Library Self-Test Bench.
 * @ingroup uvmt_{{ name }}_st_pkg
 */
package uvmt_{{ name }}_st_pkg;

   import uvm_pkg      ::*;
   import uvml_pkg     ::*;
   import uvml_logs_pkg::*;
   import uvml_sb_pkg  ::*;
   import uvml_{{ name }}_pkg::*;
   import uvme_{{ name }}_st_pkg::*;

   // Constants / Structs / Enums
   `include "uvmt_{{ name }}_st_tdefs.sv"
   `include "uvmt_{{ name }}_st_constants.sv"

   // Tests
   `include "uvmt_{{ name }}_st_test_cfg.sv"
   `include "uvmt_{{ name }}_st_base_test.sv"

endpackage : uvmt_{{ name }}_st_pkg


// Module(s) / Checker(s)
`include "uvmt_{{ name }}_st_dut_wrap.sv"
`include "uvmt_{{ name }}_st_dut_chkr.sv"
`include "uvmt_{{ name }}_st_tb.sv"


`endif // __UVMT_{{ name_uppercase }}_ST_PKG_SV__
