// Copyright {{ year }} {{ name_of_copyright_owner }}
// {{ license }}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


`ifndef __UVMT_{{ name_uppercase }}_ST_TEST_CFG_SV__
`define __UVMT_{{ name_uppercase }}_ST_TEST_CFG_SV__


/**
 * Object encapsulating common configuration parameters for {{ name_normal_case }} UVM Library Self-Tests.
 * @ingroup uvmt_{{ name }}_st_tests
 */
class uvmt_{{ name }}_st_test_cfg_c extends uvml_test_cfg_c;

   /// @defparam Knobs
   /// @{
   rand int unsigned  clk_period        ; ///< Test bench clock period (ps)
   rand int unsigned  reset_period      ; ///< Test bench reset pulse duration (ns)
   rand int unsigned  startup_timeout   ; ///< Timer ending test if no heartbeat is detected from start of simulation (ns)
   rand int unsigned  heartbeat_period  ; ///< Timer ending phase if no heartbeat is detected from start of a phase (ns)
   rand int unsigned  simulation_timeout; ///< Timer ending simulation (ns)
   /// @}

   /// @name Command line arguments
   /// @{
   /// @}


   `uvm_object_utils_begin(uvmt_{{ name }}_st_test_cfg_c)
      `uvm_field_int(clk_period        , UVM_DEFAULT + UVM_DEC)
      `uvm_field_int(reset_period      , UVM_DEFAULT + UVM_DEC)
      `uvm_field_int(startup_timeout   , UVM_DEFAULT + UVM_DEC)
      `uvm_field_int(heartbeat_period  , UVM_DEFAULT + UVM_DEC)
      `uvm_field_int(simulation_timeout, UVM_DEFAULT + UVM_DEC)
   `uvm_object_utils_end


   /**
    * Sets safe defaults for all simulation timing parameters.
    */
   constraint defaults_cons {
      clk_period         == uvmt_{{ name }}_st_default_clk_period        ;
      reset_period       == uvmt_{{ name }}_st_default_reset_period      ;
      startup_timeout    == uvmt_{{ name }}_st_default_startup_timeout   ;
      heartbeat_period   == uvmt_{{ name }}_st_default_heartbeat_period  ;
      simulation_timeout == uvmt_{{ name }}_st_default_simulation_timeout;
   }


   /**
    * Default constructor.
    */
   extern function new(string name="uvmt_{{ name }}_st_test_cfg");

   /**
    * Processes command line interface arguments.
    */
   extern function void process_cli_args();

endclass : uvmt_{{ name }}_st_test_cfg_c


function uvmt_{{ name }}_st_test_cfg_c::new(string name="uvmt_{{ name }}_st_test_cfg");

   super.new(name);

endfunction : new


function void uvmt_{{ name }}_st_test_cfg_c::process_cli_args();



endfunction : process_cli_args


`endif // __UVMT_{{ name_uppercase }}_ST_TEST_CFG_SV__
